/*[INCLUDE-IF Sidecar18-SE]*/
/*******************************************************************************
 * Copyright IBM Corp. and others 2004
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution and
 * is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 *******************************************************************************/
package com.ibm.dtfj.corereaders;

/**
 * Represents a register for a thread.  The name is very system dependent.
 */
public class Register {
	String name;
	int size;
	long value;

	public Register(String name, int size, long value) {
		this.name = name;
		this.size = size;
		long mask = 0;
		for (int i = 0; i < size; i++)
			mask = (mask << 1) | 1;
		this.value = value & mask;
	}

	/**
	 * @return the name of the register
	 */
	public String getName() {
		return name;
	}

	/**
	 * @return the number of bits in the register
	 */
	public int getSize() {
		return size;
	}

	/**
	 * @return the value held in the register
	 */
	public long getValue() {
		return value;
	}
}
