/*[INCLUDE-IF Sidecar18-SE]*/
/*******************************************************************************
 * Copyright IBM Corp. and others 2012
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution and
 * is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 *******************************************************************************/
package com.ibm.jvm.dtfjview.tools.utils;

/**
 * This class will start cache lines once any match is found. It will 
 * release the cached lines once it encounters an empty line.
 * <p>
 * @author Manqing Li
 *
 */
public class BlockPostmatchHandle implements IPostmatchHandle {

	public void justMatched() {
		this.ended = false;
	}

	public String process(String s) {
		if (ended) {
			return "";
		}
		if (null == s || 0 == s.trim().length()) {
			ended = true;
		}
		if (ended == false) {
			return s;
		} else {
			return "";
		}
	}
	
	private boolean ended = false;
}
