/*******************************************************************************
 * Copyright IBM Corp. and others 2001
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution and
 * is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 *******************************************************************************/
package jit.test.jitt.casting;

import org.testng.annotations.Test;
import org.testng.Assert;

@Test(groups = { "level.sanity","component.jit" })
public class Cast001 extends jit.test.jitt.Test {

	static class Y {
	}

	static class Z extends Y {
	}

	static class X {
		Y y;
		String stringSlot;

		public void tst_jit(Object z, boolean triggerException) {
			if (triggerException) {
				this.stringSlot = (String) z; // failing cast
			} else {
				this.y = (Z) z;
			}
		}
	}

	@Test
	public void testCast001() {
		X x = new X();
		for (int j = 0; j < sJitThreshold; j++) {
			x.tst_jit(new Z(), false);
		}

		try {
			x.tst_jit(new Z(), true);
		} catch (ClassCastException e) {
			return;
		}

		Assert.fail("Failed to generate exception");

	}

}
