/*******************************************************************************
 * Copyright IBM Corp. and others 2000
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution and
 * is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 *******************************************************************************/
package jit.test.loopReduction;

public class countDecimalDigitInt extends base {
   public int test(Context c, int len) {
      int j = 1, i, ans = 1;
      for (i = 1; i < len; i++) 
         ans *= 10;
      long start, end, elapsed;
      start = System.currentTimeMillis();
      for (int iters = 0; iters < c.iterations()*400; iters++) {
         i = 0;
         j = ans;
         while (true) {
            i++;
            j = j / 10;
            if (j == 0) 
               break;
         }
      }
      if (c.verify())
         if (len == 0) {
            if (i != 1)
               c.printerr(this.getClass().getName() + " got: " + i + " expected: 1");
         } else {
            if (i != len) 
               c.printerr(this.getClass().getName() + " got: " + i + " expected: " + len);
         }
      end = System.currentTimeMillis();
      elapsed = end - start;
      c.println(this.getClass().getName() + ": len="+ len + ", test took " + elapsed + " millis");
      return i;
   }
}
