/*******************************************************************************
 * Copyright IBM Corp. and others 2016
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution and
 * is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 *******************************************************************************/
package com.ibm.trace.tests.apptrace;

import com.ibm.jvm.Trace;

public class TestMultipleApplications { 

    public static void main(String[] args) {

        String[] templates = new String[4];

        System.out.println("TestMultipleApplications: started");
        templates[0] = Trace.EVENT;
        templates[1] = Trace.EVENT + "Tracepoint #01 %s";
        templates[2] = Trace.EVENT + "Tracepoint #02 %s";
        templates[3] = Trace.EVENT + "Tracepoint #03 %s";

        int componentId1 = Trace.registerApplication("App1",templates);
        int componentId2 = Trace.registerApplication("App2",templates);

        Trace.set("print={App1,App2}");
        
        // Trace from both components.
        Trace.trace(componentId1, 1, "from application 1");
        Trace.trace(componentId2, 1, "from application 2");
        Trace.trace(componentId1, 2, "from application 1");
        Trace.trace(componentId2, 2, "from application 2");
        Trace.trace(componentId1, 3, "from application 1");
        Trace.trace(componentId2, 3, "from application 2");
        
        System.out.println("TestMultipleApplications: finished");
        
    }

}
