/*******************************************************************************
 * Copyright IBM Corp. and others 2001
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution and
 * is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 *******************************************************************************/
package j9vm.test.threadinterrupt;

class scenario2bTest {
	public static void main(String args[]) {
		scenario2bTest t = new scenario2bTest();
		t.Run();
	}

	volatile boolean m_interruptSent = false;

	public void Run() {
		Interruptee interruptee = new Interruptee();

		System.out.println("main starting interruptee");
		interruptee.start();
		System.out.println("main interrupting interruptee");
		interruptee.interrupt();
		m_interruptSent = true;
		System.out.println("main done interrupting interruptee");
	}

	class Interruptee extends Thread {
		public void run() {
			try {
				System.out.println("interruptee spin waiting");
				while (!m_interruptSent) {
				}
				System.out.println("interruptee done spin waiting");
				sleep(100 * 1000);
				System.out.println("interruptee done sleeping");
				throw new Error("sleep should have been interrupted");
			} catch (InterruptedException ie) {
				System.out.println("SUCCESS");
			}
		}
	}

}
