/*******************************************************************************
 * Copyright IBM Corp. and others 2013
 *
 * This program and the accompanying materials are made available under
 * the terms of the Eclipse Public License 2.0 which accompanies this
 * distribution and is available at https://www.eclipse.org/legal/epl-2.0/
 * or the Apache License, Version 2.0 which accompanies this distribution and
 * is available at https://www.apache.org/licenses/LICENSE-2.0.
 *
 * This Source Code may also be made available under the following
 * Secondary Licenses when the conditions for such availability set
 * forth in the Eclipse Public License, v. 2.0 are satisfied: GNU
 * General Public License, version 2 with the GNU Classpath
 * Exception [1] and GNU General Public License, version 2 with the
 * OpenJDK Assembly Exception [2].
 *
 * [1] https://www.gnu.org/software/classpath/license.html
 * [2] https://openjdk.org/legal/assembly-exception.html
 *
 * SPDX-License-Identifier: EPL-2.0 OR Apache-2.0 OR GPL-2.0-only WITH Classpath-exception-2.0 OR GPL-2.0-only WITH OpenJDK-assembly-exception-1.0
 *******************************************************************************/
package com.ibm.jvmti.tests.redefineClasses;

import com.ibm.jvmti.tests.util.Util;
import java.lang.reflect.*;

public class rc017 {
	public static native boolean redefineMultipleClass(Class[] originalClasses, int classCount, byte[][] classBytes, int[] classBytesLength);

	public boolean testClassGrandParenetHierachy()	{
		Class noparams[] = {};
		try {
			rc017_testClassGrandParentHierachy_grandParent_0 test[] =
				{
					new rc017_testClassGrandParentHierachy_grandParent_0(),
					new rc017_testClassGrandParentHierachy_child_0()
				};

			boolean redefined = Util.redefineMultipleClass(
				getClass(),
				new Class<?>[] {rc017_testClassGrandParentHierachy_child_0.class, rc017_testClassGrandParentHierachy_grandParent_0.class},
				new Class<?>[] {rc017_testClassGrandParentHierachy_child_1.class, rc017_testClassGrandParentHierachy_grandParent_1.class}
			);

			if (!redefined) {
				System.out.println("failed to redefine classes");
				return false;
			}

			rc017_testClassGrandParentHierachy_grandParent_0 test2[] =
				{
					new rc017_testClassGrandParentHierachy_grandParent_0(),
					new rc017_testClassGrandParentHierachy_child_0()
				};

			return true;

		} catch (ArrayStoreException e) {
			System.out.println("rc017 failed to store retranformed class into array of grandparent, See CMVC 199556/JAZZ 45682 for detail");
			e.printStackTrace();
			return false;
		} catch (Exception e) {
			System.out.println("rc017 encountered unexpected exception "+ e.getMessage());
			return false;
		}
	}

	public String helpClassGrandParenetHierachy() {
		return "Tests redefining a class and its grandpaent maintains the correct super class hierachy in class";
	}



}
